﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace PlatformSDKSample
{
    using TAlarmInfo = PlatformSDK.TAlarmInfo;
    using TLoginInfo = PlatformSDK.TLoginInfo;
    using TDeviceInfo = PlatformSDK.TDeviceInfo;
    using TDeviceDetailInfo = PlatformSDK.TDeviceDetailInfo;
    using TExportFileInfo = PlatformSDK.TExportFileInfo;
    using TAlarmNotification = PlatformSDK.TAlarmNotification;
    using TManualAlarmInfo = PlatformSDK.TManualAlarmInfo;

    public static class PlatformSDK
    {
        public const int MAX_DECODE_TYPE_LEN = 15;
        public const int MAX_NODEUNIT_LEN = 40;
        public const int MAX_REFNAME_LEN = 194;
        public const int MAX_IPHOST_LEN = 128;
        public const int MAX_USERNAME_LEN = 64;
        public const int MAX_HEXPWD_LEN = 128;
        public const int MAX_MODEL_LEN = 128;
        public const int MAX_TUNNEL_RESPONSE_LENGTH = (10 * 1024 * 1024);
        public const int MAX_EVENT_TIME_LEN = 31;
        public const int MAX_EVENT_ARGS_LEN = 64;
        public const int MAX_ALARM_DESC_LEN = 1024;
        public const int MAX_DATE_LEN = 16;
        public const int MAX_LOC_NAME_LEN = 64;
        public const int MAX_REC_GROUP_NAME_LEN = 96;
        public const int MAX_REC_PATH_LEN = 384;
        public const int MAX_SUBSTATION_LAYER = 7;
        public const int MAX_SUBSTATION_PATH_LEN = MAX_NODEUNIT_LEN * MAX_SUBSTATION_LAYER;
        public const int MAX_BOOKMARK_DESCRIPTION_LEN = 1024;
        public const int MAX_VERSION_LEN = 16;
        public const int MAX_URL_LEN = 2048;
        public const int MAX_FIRMWARE_VERSION_LEN = 32;
        public const int MAX_MAC_LEN = 12;
        public const int MAX_PRESET_NAME_LEN = 40;

        public const int TUNNEL_CONNECT = 0;
        public const int TUNNEL_DISCONNECT = 1;

        public static readonly uint GENERAL_E_FAIL = 0xFFFFFFFF;

        public static readonly uint GENERAL_E_VNDP_INVALID_HANDLE = 0x80000001;
        public static readonly uint GENERAL_E_VNDP_OUT_OF_MEMORY = 0x80000002;
        public static readonly uint GENERAL_E_VNDP_INVALID_ARG = 0x80000003;
        public static readonly uint GENERAL_E_VNDP_NOT_IMPLEMENT = 0x80000004;
        public static readonly uint GENERAL_E_VNDP_INVALID_VERSION = 0x80000005;

        public static readonly uint SERVER_CONNECTION_E_VNDP_TUNNEL_NOT_STARTUP = 0x80700101;
        public static readonly uint SERVER_CONNECTION_E_VNDP_TUNNEL_NOT_EXIST = 0x80700102;
        public static readonly uint SERVER_CONNECTION_E_VNDP_TUNNEL_ALREADY_EXIST = 0x80700103;
        public static readonly uint SERVER_CONNECTION_E_VNDP_TUNNEL_CREATE_FAIL = 0x80700104;
        public static readonly uint SERVER_CONNECTION_E_VNDP_TUNNEL_SEND_MESSAGE_FAIL = 0x80700108;
        public static readonly uint SERVER_CONNECTION_E_EVENT_SERVER_NOT_LOGIN = 0x80700111;
        public static readonly uint SERVER_CONNECTION_E_QUERY_SERVER_NOT_LOGIN = 0x80700112;
        public static readonly uint SERVER_CONNECTION_E_CONFIG_SERVER_NOT_LOGIN = 0x80700115;
        public static readonly uint SERVER_CONNECTION_E_LOGIN_WITH_EMPTY_USERNAME = 0x80700116;
        public static readonly uint SERVER_CONNECTION_E_LOGIN_WITH_EMPTY_PASSWORD = 0x80700117;

        public enum EFisheyeMountType : uint
        {
            unknown,
            wall,
            ceiling,
            floor,
            nonFisheyeCamera
        }

        public enum EFisheyeDisplayMode : uint
        {
            mode_None,
            mode_1O,
            mode_1O_Unstretched,
            mode_1R,
            mode_1P,
            mode_2P_Unstretched,
            mode_2P,
            mode_1P2R,
            mode_1O3R,
            mode_4R,
            mode_4R_Interfered,
            mode_1P3R,
            mode_1O8R,
            mode_1P3R_TopPanorama,
            mode_1P2R_TopPanorama,
        }

        public enum EMouseEventType : uint
        {
            leftDown,
            leftUp,
            middleDown,
            middleUp,
            rightDown,
            rightUp,
            leftDoubleClick,
            middleDoubleClick,
            rightDoubleClick,
            move,
            dragging,
            wheelRotation,
        }

        public enum EMediaType : uint
        {
            e3gp,
            eAVI
        }

        public enum EDeviceType : uint
        {
            unknown,
            camera,
            externalDevice,
            station,
            cmsStation,
        }

        public enum EEventType : uint
        {
            unknown,
            DI,
            DO,
            motion,
            PIR,
            tampering,
            videoLoss,
            fanStatus,
            storageConn,
            storageCap,
            storageVoid,
        }

        public enum EStreamInitStatus : uint
        {
            play,
            pause,
        }

        public enum EConnectionStatus : uint
        {
            unchanged,
            connected,
            disconnected,
            receiveHeartBeat,
            heartBeatLost,
            heartBeatLostRetry,
        }

        public enum ERecordingStatus : uint
        {
            stop,
            start,
            unchanged,
        }

        public enum EServerType : uint
        {
            configServer,
            eventServer,
            queryServer,
        }

        public enum EStreamSource : uint
        {
            VAST,
            CMS,
        }

        public enum EStreamMode : uint
        {
            normalStream,
            retrieveOneSnapshot,
        }

        public enum ETimeType : uint
        {
            recordingTime,
            cameraTime,
        }

        public enum ERawDataFormat : uint
        {
            RGB24,
            RGB32,
            YUV
        }

        public enum EStreamStatus : uint
        {
            ok,
            timeout,
            otherError,
            stopped,
            authFailed,
            exportFinish,
            badRequest,
            maxConnections,
            clientForbidden,
            cameraUnreachable,
            byePacket,
            exportError
        }

        public enum EVideoDecodeType : uint
        {
            JPEG,
            BMP24,
            BMP32,
            YUV,
            YV12,
        }

        public enum EPTZType : uint
        {
            physicalPTZ,
            ePTZ,
        }

        public enum EPTZCommand : uint
        {
            right,
            left,
            up,
            down,
            home,
            leftUp,
            rightUp,
            leftDown,
            rightDown,
            focusAuto,
            focusNear,
            focusFar,
            zoomIn,
            zoomOut,
            startPan,
            startPatrol,
            stopPan,
            irisAuto,
            irisOpen,
            irisClose,
            setHome,
            defaultHome,
        }

        public enum ENVRLogType : uint
        {
            system,
            recording,
            user,
            error,
            abnormalEvent,
            unknown,
        }

        public enum ETimeKind : uint
        {
            local,
            UTC,            
        }

        public enum ETimeSource : uint
        {
            cameraTime,
            recordingTime,
        }

        public enum EPlayDirection : uint
        {
            forward,
            backward,
        }

        public enum EManualRecordingAction : uint
        {
            start,
            stop,
        }

        public enum ESystemShutdownAction : uint
        {
            shutdown,
            reboot,
        }

        public enum ERecordingPathType : uint
        {
            unknown,
            local,
            networkDomain,
            networkHost,
        }

        public enum ERecordingState : uint
        {
            none,
            scheduled,
            manual,
            byEvent,
            continuous,
            unknown,
        }

        public enum ESeamlessState : uint
        {
            notRecovering,
            recoveringMedia,
            recoveringEvent,
        }

        public enum ECapabilityVersion : uint
        {            
	        VAST,
	        NVR,
	        CMS,
            unknown,
        }

        public enum EHttpMethod : uint
        { 
            GET,
            POST,
        }

        public enum ESDKRequestStatus : uint
        {
            none,
            timeout,
            terminate,
            responsePart,
            responseComplete,
        }

        public enum EHardwareAcceleration : uint
        {
            none,
            Nvidia_CUDA,
            Microsoft_DXVA2,
            Intel_QuickSync,
        }

        public enum EVideoDisplayMode : uint
        {
            fillViewCell,
	        keepAspectRatio,	
        }

        public enum EPlaybackMode : uint
        {
            normal,
	        download,
	        synchronous,
        }

        public enum EStreamCodecType : uint
        {
            video_JPEG,
            video_H263,
            video_MP4,
            video_H264,
            video_H265,
            video_Dummy,
            audio_G7221,
            audio_G729A,
            audio_AAC,
            audio_GAMR,
            audio_SAMR,
            audio_G711,
            audio_G711A,
            audio_G726,
            audio_Dummy,
            iva,
            metx,
            metj,
            unknown,
        }
 
        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TServerStatusInfo
        {
            public IntPtr hLoginID;
            public EServerType serverType;
            public EConnectionStatus status;
            public IntPtr context;
        };

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TEventInfo
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string deviceID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_EVENT_TIME_LEN + 1)]
            public string time;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_EVENT_ARGS_LEN + 1)]
            public string args;
            public EDeviceType deviceType;
            public EEventType eventType;
            public byte init;
            public byte trigger;
            public int index;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TDeviceRecordingStatusInfo
        {
            public ERecordingState deviceRecordingState;
            public ERecordingState groupRecordingState;
            public uint groupID;
            public ESeamlessState seamlessState;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TDeviceStatusInfo
        {
            public EDeviceType deviceType;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string deviceID;
            public EConnectionStatus connectionStatus;
            public IntPtr recordingStatusInfo;          //if non-zero, it pointer to TDeviceRecordingStatusInfo
            public bool init;
            public ERecordingStatus recordingStatus;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TCameraStatusList
        {
            public IntPtr statusList;     //pointer to TDeviceStatusInfo
            public uint statusNum;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TDeviceInfo
        {
            public EDeviceType deviceType;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string deviceID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_REFNAME_LEN + 1)]
            public string refName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_IPHOST_LEN + 1)]
            public string IP;
            public uint port;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_USERNAME_LEN + 1)]
            public string userName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_HEXPWD_LEN + 1)]
            public string password;
            public int channelIndex;    //start from 1
            public int DINum;
            public int DONum;
        };

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TDeviceDetailInfo
        {
            public EDeviceType deviceType;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string deviceID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_REFNAME_LEN + 1)]
            public string refName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_IPHOST_LEN + 1)]
            public string IP;
            public uint port;
            public int DINum;
            public int DONum;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_FIRMWARE_VERSION_LEN + 1)]
            public string firmwareVersion;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_MAC_LEN + 1)]
            public string mac;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_MODEL_LEN + 1)]
            public string modelName;
            public int fisheyeCapability;
            public int ptzCapability;
            public int streamNum;
            public bool supportPTZ;
        };

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TAlarmInfo
        {
            public int ID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_REFNAME_LEN + 1)]
            public string alarmName;
            public IntPtr content;
            public uint contentLen;
            public bool enabled;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TAbnormalEventInfo
        {
            public IntPtr content;
            public uint contentLen;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TManualAlarmInfo
        {
            public int ID;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_ALARM_DESC_LEN + 1)]
            public byte[] szUTF8Description;        //must be UTF8 encoding and end with character '\0'.
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TAlarmNotification
        {
            public IntPtr content;
            public uint contentLen;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TSnapshotCallbackInfo
        {
            public IntPtr image;
            public int imageSize;       //unit: Byte
            public IntPtr context;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TVideoDecodeInfo
        {
            public IntPtr hChannel;
            public IntPtr pBuffer;
            public int bufSize;
            public int height;
            public int width;
            public uint frameSecond;
            public uint frameMilSec;
            public IntPtr context;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TStreamDataInfo
        {
            public IntPtr hChannel;
            public int width;
            public int height;
            public uint frameLocalTimeSecond;
            public uint frameLocalTimeMilSec;
            public IntPtr context;
            public uint frameUTCTimeSecond;
            public uint frameUTCTimeMilSec;
            public EStreamCodecType codecType;
            public uint bitRate;
            public uint frameSize;
            public bool dummyPacket;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TStreamStatusInfo
        {
            public IntPtr hChannel;
            public EStreamStatus status;
            public IntPtr context;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TEventListInfo
        {
            public IntPtr pEventList;      //pointer to array of TEventInfo
            public uint eventNum;
            public IntPtr rawContent;
            public uint rawContentLen;
            public IntPtr context;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TStreamingDisplayInfo
        {
            public bool showFrameTime;
            public bool showMillisecond;
            public ETimeSource timeSource;
            public ETimeKind timeKind;
            public uint ARGBTextColor;
            public uint fontSize;
			public bool showTextShadow;
            public bool opaqueBackground;
            public uint ARGBBackgroundColor;
        }

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfSyncStatusCallback(IntPtr context);

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TSDKSyncPlaybackOption
        {
            public uint startTime;
            public uint endTime;
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfSyncStatusCallback statusCB;
            public IntPtr statusContext;
            public ETimeKind timeKind;
            public uint startTimeMilSec;
            public uint endTimeMilSec;
        }

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfDeviceStatusCallBack(IntPtr pStatusList, int statusNum, IntPtr context);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfEventCallBack(IntPtr pEventListInfo);    //pEventListInfo pointer to TEventListInfo

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfAlarmNotificationCallBack(IntPtr pAlarmList, int alarmNum, IntPtr context);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfMessCallBack(IntPtr pStatusInfo);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfStreamDataCallBack(IntPtr pStreamDataInfo);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfYV12DataCallBack(IntPtr hChannel, IntPtr pBuffer, uint bufferSize
            , int height, int width, int dataType, IntPtr context);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfPCMDataCallBack(IntPtr hChannel, IntPtr pBuffer, uint bufferSize
            , uint samplingFreq, uint samplingSize, uint channelNum, IntPtr context);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfVideoDecodeCallBack(IntPtr pVideoDecodeInfo);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfStreamStatusCallBack(IntPtr pStatusInfo);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfSnapshotCallBack(IntPtr pSnapshotInfo);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfHeartbeatCallBack(IntPtr pStatusInfo);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfExportInfoCallBack(IntPtr pExportInfo);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfNonBlockedRequestCallBack(IntPtr response, uint responseLen, ESDKRequestStatus status, IntPtr context);
        
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfHttpRequestCallBack(IntPtr message, uint messageLen, IntPtr context);
        
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void pfRawDataCallBack(IntPtr hChannel, IntPtr pBuffer, uint bufferSize
            , int height, int width, uint frameSecond, uint frameMSec);

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TStreamInfo
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_IPHOST_LEN + 1)]
            public string serverIP;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_USERNAME_LEN + 1)]
            public string serverUserName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_HEXPWD_LEN + 1)]
            public string serverPassword;
            public int serverPort;
            public IntPtr hDisplayWindow;
            public EStreamSource streamSource;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_SUBSTATION_PATH_LEN + 1)]
            public string substationPath;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string cameraID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_REFNAME_LEN + 1)]
            public string cameraRefName;
            public short streamIndex;
            public uint startTime;
            public uint endTime;
            public IntPtr context;
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfStreamDataCallBack pfStreamDataCB;
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfYV12DataCallBack pfYV12DataCB;
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfPCMDataCallBack pfPCMDataCB;
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfVideoDecodeCallBack pfVideoDecodeCB;
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfStreamStatusCallBack pfStreamStatusCB;
            public EVideoDecodeType decodeType;
            public EStreamMode streamMode;
            public ETimeType timeType;
            public EPlayDirection playDirection;
            public EStreamInitStatus streamInitStatus;
            public ETimeKind timeKind;
            public ECapabilityVersion capVersion;
            public bool useSSL;
            public EVideoDisplayMode videoDisplayMode;
            public EPlaybackMode playbackMode;
            public uint rateLimit;
            public uint iFrameOnlyInterval;
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfRawDataCallBack pfRawDataCB;
            public ERawDataFormat rawDataFormat;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TDigitalZoomInfo
        {
            public int top;
            public int bottom;
            public int left;
            public int right;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TLocalFileInfo
        {
            public IntPtr hDisplayWindow;
            public string filePath;
            public EHardwareAcceleration hardwareAcceleration;
        }

        [Serializable, StructLayout(LayoutKind.Sequential)]
        public struct TLoginInfo
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_IPHOST_LEN + 1)]
            public string IP;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_USERNAME_LEN + 1)]
            public string userName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_HEXPWD_LEN + 1)]
            public string password;
            public int port;
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfMessCallBack pfMessCB;
            public IntPtr context;
            public uint timeoutSeconds;
            public bool blockLogin;                 //false = non-block, true = block login until success or timeout
            public uint heartBeatLostRetryTimes;
            public uint heartbeatPeriodSeconds;
            public uint VAST2WebSocketPort;         //used for VAST2
            public bool useSSL;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TExportFileInfo
        {
            public EMediaType mediaType;			    // input EMediaType: 3gp, avi, ...
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_IPHOST_LEN + 1)]
            public string serverIP;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_USERNAME_LEN + 1)]
            public string serverUserName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_HEXPWD_LEN + 1)]
            public string serverPassword;
            public int serverPort;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_SUBSTATION_PATH_LEN + 1)]
            public string substationPath;               // main station = ""
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string cameraID;
            public short streamIndex;		            // camera stream index, start from 1
            public int startTime;		                // start time seconds, (dt - new DateTime (1970, 1, 1)).TotalSeconds
            public int endTime;			                // end time seconds
            public IntPtr context;		                // user define callback context
            public string exportDir;		            // directory of export file
            public string exportFilename;	            // filename of export file            
            public pfStreamStatusCallBack pfExportStatusCB;     // callback function to notify export finish
            public pfExportInfoCallBack pfExportInfoCB;         // callback function to notify export progress
            public bool useSSL;
            public int rateLimit;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TLiveSnapshotRequest
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string cameraID;
            public uint channelIndex;		            // camera channel index, start from 0
            public uint streamIndex;		            // camera stream index, start from 0
            public uint width;                          // for resize, set 0 for actual size
            public uint height;                         // for resize, set 0 for actual size
            public uint timeoutSeconds;
            public bool IFrameOnly;                     // only retrieve snapshot of I-frame
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfSnapshotCallBack pfSnapshotCB;
            public IntPtr context;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TPlaybackSnapshotRequest
        {
            public uint timeSeconds;	                // total seconds of retrieve time
            public uint millisceondsOfTime;		        //the milliseconds of the retrieval time, range: 0 ~ 999
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string cameraID;
            public uint width;                          // for resize, set 0 for actual size
            public uint height;                         // for resize, set 0 for actual size
            public uint timeoutSeconds;
            public ETimeKind timeKind;					//local time or UTC time
            public ETimeType timeType;					//recording time or camera time
            public bool IFrameOnly;                     // only retrieve snapshot of I-frame
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfSnapshotCallBack pfSnapshotCB;
            public IntPtr context;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TChannelSnapshotInfo
        {
            public IntPtr pszOutputDir;
            public IntPtr pszFileName;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TDeviceListRequest
        {
            public uint timeoutMillisecond;
            public string stationID;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TPlaybackOption
        {
            public uint startTime;                  // time_t value
            public uint endTime;                    // time_t value
            public EPlayDirection ePlayDirection;
            public uint startTimeMilisec;
            public uint endTimeMilisec;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TDeviceListResponse
        {
            public IntPtr pDeviceList;  //pointer to TDeviceInfo
            public int deviceNum;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TDeviceDetailListResponse
        {
            public IntPtr pDeviceList;  //pointer to TDeviceDetailInfo
            public int deviceNum;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TPTZRequest
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string cameraID;
            public uint channelIndex;   //start from 1
            public uint streamIndex;    //start from 1
            public EPTZType PTZType;
            public EPTZCommand command;
            public int speed;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TContinuousPTZRequest
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string cameraID;
            public uint channelIndex;
            public uint streamIndex;
            public int speed;
            public int x;
            public int y;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TQueryNVRLogRequest
        {
            public uint startTime;
            public uint endTime;
            public uint maxRecords;
            public ENVRLogType logType;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TQueryAlarmRequest
        {
            public uint startTime;
            public uint endTime;
            public uint maxRecords;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TQueryAlarmResponse
        {
            public IntPtr content;
            public uint contentLength;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TQueryNVRLogResponse
        {
            public IntPtr content;
            public uint contentLength;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingDate
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_DATE_LEN + 1)]
            public string date;
            public int dayLightSavingSecond;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingDateList
        {
            public uint dateNum;
            public IntPtr dateList;    //pointer to TRecordingDate
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public struct TSDKPreset
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_PRESET_NAME_LEN + 1)]
            public string szPresetName;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TSDKPresetList
        {
            public uint dwPresetNum;
            public IntPtr ptPresetList;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingDeviceInfo
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string deviceID;	            //Camera (C_XXX)
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_REFNAME_LEN + 1)]
            public string refName;              //device reference name
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_LOC_NAME_LEN + 1)]
            public string locationID;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingDeviceList
        {
            public IntPtr deviceList;           //pointer to TRecordingDeviceInfo
            public uint deviceNum;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TTimeInterval
        {
            public uint startSecond;
            public uint startMilSec;
            public int startDayLightSavingSecond;
            public int startTimeZoneSecond;
            public uint endSecond;
            public uint endMilSec;
            public int endDayLightSavingSecond;
            public int endTimeZoneSecond;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingTime
        {
            public TTimeInterval tServerTime;
            public TTimeInterval tCameraTime;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingTimeReqInfo
        {
            public uint timeoutMillisecond;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_LOC_NAME_LEN + 1)]
            public string locationID;
            public uint utcStartTimeSeconds;
            public uint utcEndTimeSeconds;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingDateReqInfo
        {
            public uint timeoutMillisecond;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_LOC_NAME_LEN + 1)]
            public string locationID;
            public uint utcStartTimeSeconds;
            public uint utcEndTimeSeconds;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingTimeList
        {
            public IntPtr timeList;     //pointer to TRecordingTime
            public uint timeNum;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TMouseEvent
        {
            public EMouseEventType eventType;
            public int x;
            public int y;
            public int wheelRotation;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TManualRecordingRequestDevice
        {
            public string deviceID;
            public uint groupID;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TManualRecordingRequest
        {
            public EManualRecordingAction eRecAction;
            public uint timeoutMillisecond;
            public IntPtr deviceList;               //pointer to TManualRecordingRequestDevice
            public uint deviceNum;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TSystemShutdownReqInfo
        {
            public ESystemShutdownAction eAction;
            public string substationPath;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingGroupReqInfo
        {
            public uint timeoutMillisecond;
            public string stationID;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingGroupDeviceInfo
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string deviceID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_REFNAME_LEN + 1)]
            public string refName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_LOC_NAME_LEN + 1)]
            public string locationID;
            public uint streamIndex;
            public uint preEventSecond;
            public uint postEventSecond;
            public bool enableTimeShift;
            public bool enableSeamless;
            public bool enableKeyFrameOnly;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingGroupPathInfo
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_REC_PATH_LEN + 1)]
            public string path;
            public bool bConnected;
            public uint reserveSpace;
            public ERecordingPathType type;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_IPHOST_LEN + 1)]
            public string hostDomain;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_USERNAME_LEN + 1)]
            public string hostUsername;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_HEXPWD_LEN + 1)]
            public string hostPassword;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingGroup
        {
            public uint groupID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_REC_GROUP_NAME_LEN + 1)]
            public string groupName;
            public IntPtr pathList;             //pointer to TRecordingGroupPathInfo
            public uint pathNum;
            public IntPtr deviceList;           //pointer to TRecordingGroupDeviceInfo
            public uint deviceNum;
            public bool enableTimeBaseCycle;
            public uint reserveCycleMinute;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TRecordingGroupList
        {
            public IntPtr groupList;       //pointer to TRecordingGroup
            public uint groupNum;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TExportStreamInfo
        {
            public IntPtr hChannel;
            public IntPtr context;
            public int exportingProgress;   //percentage value: 0 ~ 100
        }


        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TGetCameraStatusReqInfo
        {
            public bool getAllCameraStatus;            
            public string cameraID;
            public uint timeoutMillisecond;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct DeviceRecordingStatusInfo
        {
            public ERecordingState deviceRecordingState;
            public ERecordingState groupRecordingState;
            public uint groupID;
            public ESeamlessState seamlessState;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TNonBlockedRequestInfo
        {
            public EServerType serverType;
            public string commandName;
            public IntPtr commandBody;
            [MarshalAs(UnmanagedType.FunctionPtr)]
            public pfNonBlockedRequestCallBack callback;
            public IntPtr context;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TBlockedRequestInfo
        {
            public EServerType serverType;
            public string commandName;
            public IntPtr commandBody;
            public uint timeoutMillisecond;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TBlockedResponseInfo
        {
            public IntPtr content;
            public uint contentLen;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TBookmark
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string bookmarkID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
            public string cameraID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_BOOKMARK_DESCRIPTION_LEN + 1)]
            public string describe;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_USERNAME_LEN + 1)]
            public string creator;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TBookmarkList
        {
            public IntPtr bookmarkList;     //pointer to TBookmark list
            public uint bookmarkNum;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TBookmarkRequest
        {
	        public uint dwTimeoutSeconds;		//set 0 will use the internal default timeout seconds
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TServerInfo
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_NODEUNIT_LEN + 1)]
	        public string stationID;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_REFNAME_LEN + 1)]
	        public string refName;		//the reference name
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_IPHOST_LEN + 1)]
	        public string IP;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_VERSION_LEN + 1)]
	        public string version;
	        public uint	HTTPPort;
	        public uint	HTTPSPort;
	        public uint	RTSPPort;
	        public uint	VCAHTTPSPort;
	        public bool	enableWebAccess;
	        public ECapabilityVersion capVersion;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct THttpRequest
        {
            public EHttpMethod method;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_URL_LEN + 1)]
	        public string URL;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_USERNAME_LEN + 1)]
	        public string userName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = MAX_HEXPWD_LEN + 1)]
	        public string password;
	        public string POSTData;
	        public uint POSTDataLen;
	        public string header;
	        public uint headerLen;
	        public uint timeoutSeconds;
	        public pfHttpRequestCallBack callback;
	        public IntPtr context;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TSDKChannelList
        {
            public uint dwChannelNum;
            public IntPtr ptChannelList;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4), Serializable]
        public unsafe struct TSnapshotRawInfo
        {
            public IntPtr pBuffer;
            public int bufSize;
            public int height;
            public int width;
        }

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_Initial")]
        static public extern unsafe int Initial();

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_Release")]
        static public extern unsafe int Release();

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_Login")]
        static public extern unsafe uint Login(ref IntPtr phLoginID, ref TLoginInfo ptLoginOption);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_Logout")]
        static public extern unsafe uint Logout(ref IntPtr phLoginID);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetDeviceList")]
        unsafe public static extern int GetDeviceList(IntPtr hLoginID, ref TDeviceListRequest request, ref TDeviceListResponse response);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetDeviceListWithDetails")]
        unsafe public static extern int GetDeviceListWithDetails(IntPtr hLoginID, ref TDeviceListRequest request, ref TDeviceDetailListResponse response);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetAlarmInfoList")]
        unsafe public static extern int GetAlarmInfoList(IntPtr hLoginID, ref IntPtr ppAlarmInfoList, int* pdwAlarmInfoNum);
        
        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_QueryAlarm")]
        unsafe public static extern int QueryAlarm(IntPtr hLoginID, ref TQueryAlarmRequest request, ref IntPtr response, int* pdwQueryAlarmNum);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_QueryNVRLogList")]
        unsafe public static extern int QueryNVRLogList(IntPtr hLoginID, ref TQueryNVRLogRequest request, ref IntPtr response, int* pdwQueryNVRLogNum);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetLiveAbnormalEventList")]
        unsafe public static extern uint GetLiveAbnormalEventList(IntPtr hLoginID, ref IntPtr ppAbnormalEventInfoList, int* pdwAbnormalEventInfoNum);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_TriggerAlarm")]
        unsafe public static extern int TriggerAlarm(IntPtr hLoginID, ref TManualAlarmInfo alarmInfo);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_UpdateAlarm")]
        unsafe public static extern int UpdateAlarm(IntPtr hLoginID, IntPtr pszMessage);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_MonitorAlarmNotification")]
        unsafe public static extern int MonitorAlarmNotification(IntPtr hLoginID, pfAlarmNotificationCallBack pfAlarmNotificationCB, IntPtr context);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_MonitorDeviceStatus")]
        unsafe public static extern int MonitorDeviceStatus(IntPtr hLoginID, pfDeviceStatusCallBack statusCB, IntPtr context);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_MonitorEvent")]
        unsafe public static extern int MonitorEvent(IntPtr hLoginID, pfEventCallBack eventCB, IntPtr context);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SetDO")]
        static public extern unsafe int SetDO(IntPtr hLoginID, IntPtr deviceID, int index, int value);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SetNVRDO")]
        static public extern unsafe int SetNVRDO(IntPtr hLoginID, int index, int value);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_ClosePopupWindow")]
        static public extern unsafe int ClosePopupWindow(IntPtr hLoginID, int* camIDList, int camNum);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetLiveSnapshot")]
        static public extern unsafe int GetLiveSnapshot(IntPtr hLoginID, ref TLiveSnapshotRequest request);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetPlaybackSnapshot")]
        static public extern unsafe int GetPlaybackSnapshot(IntPtr hLoginID, ref TPlaybackSnapshotRequest request);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetBookmarkList")]
        static public extern unsafe int GetBookmarkList(IntPtr hLoginID, ref TBookmarkRequest request, ref TBookmarkList bookmarkList);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetServerInfo")]
        static public extern unsafe int GetServerInfo(IntPtr hLoginID, ref TServerInfo serverInfo);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_CreateLiveChannel")]
        static public extern unsafe int CreateLiveChannel(ref IntPtr phChannel, ref TStreamInfo streamInfo);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_DeleteLiveChannel")]
        static public extern unsafe int DeleteLiveChannel(ref IntPtr phChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_CreateNetFileChannel")]
        static public extern unsafe int CreateNetFileChannel(ref IntPtr phChannel, ref TStreamInfo streamInfo);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_DeleteNetFileChannel")]
        static public extern unsafe int DeleteNetFileChannel(ref IntPtr phChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_CreateLocalFileChannel")]
        static public extern unsafe int CreateLocalFileChannel(ref IntPtr phChannel, ref TLocalFileInfo localFileInfo);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_DeleteLocalFileChannel")]
        static public extern unsafe int DeleteLocalFileChannel(ref IntPtr phChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_CreateExportMediaFileChannel")]
        static public extern unsafe int CreateExportMediaFileChannel(ref IntPtr phChannel, ref TExportFileInfo exportFileInfo);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_DeleteExportMediaFileChannel")]
        static public extern unsafe int DeleteExportMediaFileChannel(ref IntPtr phChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SaveChannelSnapshot")]
        static public extern unsafe int SaveChannelSnapshot(IntPtr hChannel, ref TChannelSnapshotInfo snapshotInfo);
        
        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetChannelSnapshot")]
        static public extern unsafe int GetChannelSnapshot(IntPtr hChannel, ref TSnapshotRawInfo snapshotRawInfo);
        
        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetFisheyeChannelSnapshot")]
        static public extern unsafe int GetFisheyeChannelSnapshot(IntPtr hChannel, IntPtr hWindow, ref TSnapshotRawInfo snapshotRawInfo);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_StartChannel")]
        static public extern unsafe int StartChannel(IntPtr hChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_StopChannel")]
        static public extern unsafe int StopChannel(IntPtr hChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_PauseChannel")]
        static public extern unsafe int PauseChannel(IntPtr hChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_PTZControl")]
        static public extern unsafe int PTZControl(IntPtr hLoginID, ref TPTZRequest request);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_ContinuousPTZControl")]
        static public extern unsafe int ContinuousPTZControl(IntPtr hLoginID, ref TContinuousPTZRequest request);
        
        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_StopPTZControl")]
        static public extern unsafe int StopPTZControl(IntPtr hLoginID, ref TContinuousPTZRequest request);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SetDisplayInfo")]
        static public extern unsafe int SetDisplayInfo(IntPtr hChannel, ref TStreamingDisplayInfo displayInfo);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_UpdatePlaybackOption")]
        static public extern unsafe int UpdatePlaybackOption(IntPtr hChannel, ref TPlaybackOption option);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_UpdatePlaybackDirection")]
        static public extern unsafe int UpdatePlaybackDirection(IntPtr hChannel, EPlayDirection playDirection);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_ChangeSpeed")]
        static public extern unsafe int ChangeSpeed(IntPtr hChannel, float speed); //speed range from 0.125 to 64

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_NextFrame")]
        static public extern unsafe int NextFrame(IntPtr hChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetRecordingDeviceList")]
        static public extern unsafe int GetRecordingDeviceList(IntPtr hLoginID, ref TDeviceListRequest request, ref TRecordingDeviceList deviceList);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetRecordingDateList")]
        static public extern unsafe uint GetRecordingDateList(IntPtr hLoginID, ref TRecordingDateReqInfo request, ref TRecordingDateList dateList);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetRecordingTimeList")]
        static public extern unsafe uint GetRecordingTimeList(IntPtr hLoginID, ref TRecordingTimeReqInfo request, ref TRecordingTimeList timeList);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetFisheyeMountType")]
        static public extern unsafe int GetFisheyeMountType(IntPtr hChannel, ref EFisheyeMountType eType);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SetFisheyeMouseEvent")]
        static public extern unsafe int SetFisheyeMouseEvent(IntPtr hChannel, ref TMouseEvent mouseEvent);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SetFisheyeDisplayMode")]
        static public extern unsafe int SetFisheyeDisplayMode(IntPtr hChannel, EFisheyeDisplayMode eMode);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetAvSynchronizerChannelHandle")]
        static public extern unsafe int GetAvSynchronizerChannelHandle(IntPtr hChannel, ref IntPtr hAvSyncChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetRecordingGroup")]
        static public extern unsafe int GetRecordingGroup(IntPtr hChannel, ref TRecordingGroupReqInfo request, ref TRecordingGroupList recGroupList);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_ManualRecording")]
        static public extern unsafe int SetManualRecording(IntPtr hChannel, ref TManualRecordingRequest request);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SystemShutdown")]
        static public extern unsafe int SetSystemShutdown(IntPtr hLoginID, ref TSystemShutdownReqInfo reqInfo);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_BlockedSetDO")]
        static public extern unsafe int BlockedSetDO(IntPtr hLoginID, IntPtr deviceID, uint index, uint value, uint timeoutMilSec);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_Relogin")]
        static public extern unsafe int Relogin(IntPtr hLoginID, EServerType serverType);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetCameraStatus")]
        static public extern unsafe int GetCameraStatus(IntPtr hLoginID, ref TGetCameraStatusReqInfo request, ref TCameraStatusList statusList);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_BlockedSendRequest")]
        static public extern unsafe int BlockedSendRequest(IntPtr hLoginID, ref TBlockedRequestInfo request, ref TBlockedResponseInfo response);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_NonBlockedSendRequest")]
        static public extern unsafe int NonBlockedSendRequest(IntPtr hLoginID, ref TNonBlockedRequestInfo request);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SendHttpRequest")]
        static public extern unsafe int SendHttpRequest(ref THttpRequest request);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_AudioOn")]
        static public extern unsafe int AudioOn(IntPtr hChannel, bool bOn);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_CreateSyncPlaybackGroup")]
        static public extern unsafe int CreateSyncPlaybackGroup(ref IntPtr hPlaybackGroup);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_DeleteSyncPlaybackGroup")]
        static public extern unsafe int DeleteSyncPlaybackGroup(ref IntPtr hPlaybackGroup);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_InsertChannelToGroup")]
        static public extern unsafe int InsertChannelToGroup(IntPtr hPlaybackGroup, IntPtr hChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_RemoveChannelFromGroup")]
        static public extern unsafe int RemoveChannelFromGroup(IntPtr hPlaybackGroup, IntPtr hChannel);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SyncPause")]
        static public extern unsafe int SyncPause(IntPtr hPlaybackGroup);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SyncResume")]
        static public extern unsafe int SyncResume(IntPtr hPlaybackGroup);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SyncNextFrame")]
        static public extern unsafe int SyncNextFrame(IntPtr hPlaybackGroup);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_SetSyncSpeed")]
        static public extern unsafe int SetSyncSpeed(IntPtr hPlaybackGroup, float speed); //speed range from 0.125 to 64

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_UpdateSyncPlaybackOption")]
        static public extern unsafe int UpdateSyncPlaybackOption(IntPtr hPlaybackGroup, ref TSDKChannelList channelList, ref TPlaybackOption option);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_ReconnectSyncPlaybackChannel")]
        static public extern unsafe int ReconnectSyncPlaybackChannel(IntPtr hPlaybackGroup, IntPtr hChannel, ref TPlaybackOption option);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_ChangeSyncSpeed")]
        static public extern unsafe int ChangeSyncSpeed(IntPtr hPlaybackGroup, ref TSDKChannelList channelList, float speed, ref TPlaybackOption option);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_StartSyncPlaybackGroup")]
        static public extern unsafe int StartSyncPlaybackGroup(IntPtr hAvSyncPlaybackGroup, ref TSDKSyncPlaybackOption option);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_StopSyncPlaybackGroup")]
        static public extern unsafe int StopSyncPlaybackGroup(IntPtr hAvSyncPlaybackGroup);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_DeleteAbnormalEvent")]
        static public extern unsafe uint DeleteAbnormalEvent(IntPtr hLoginID, IntPtr eventID);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_DeleteAllAbnormalEvent")]
        static public unsafe extern uint DeleteAllAbnormalEvent(IntPtr hLoginID);

        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_GetPresetList")]
        static public extern unsafe uint GetPresetList(IntPtr hLoginID, IntPtr camID, ref TSDKPresetList presetList);
        
        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_MoveToPreset")]
        static public extern unsafe uint MoveToPreset(IntPtr hLoginID, IntPtr camID, IntPtr presetName);
        
        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_StartDigitalZoom")]
        static public extern unsafe int StartDigitalZoom(IntPtr hChannel, ref TDigitalZoomInfo digitalZoomInfo);
        
        [DllImport("PlatformSDK.dll", CharSet = CharSet.Unicode, EntryPoint = "PlatformSDK_StopDigitalZoom")]
        static public extern unsafe int StopDigitalZoom(IntPtr hChannel);
    }
}
