﻿using System;
using System.Runtime.InteropServices;
using System.Windows;

using PlatformSDKSample;

namespace QueryAlarm
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private IntPtr loginID = IntPtr.Zero;

        public MainWindow()
        {
            int retInitial = PlatformSDK.Initial();
            EventLog.Write("PlatformSDK.Initial Ret = {0:X}", retInitial);

            PlatformSDK.TLoginInfo loginInfo = new PlatformSDK.TLoginInfo();
            loginInfo.IP = "10.16.105.85";
            loginInfo.userName = "admin";
            loginInfo.password = "aaaa1111";
            loginInfo.port = 3454;
            loginInfo.VAST2WebSocketPort = 7768;        //only used for VAST2
            loginInfo.heartbeatPeriodSeconds = 5;
            loginInfo.useSSL = false;

            uint retLogin = PlatformSDK.Login(ref loginID, ref loginInfo);
            EventLog.Write("PlatformSDK.Login Ret = {0:X}", retLogin);

            InitializeComponent();
        }

        private unsafe void Button_Click(object sender, RoutedEventArgs e)
        {
            var request = new PlatformSDK.TQueryAlarmRequest();

            request.maxRecords = uint.Parse(MaxRecord.Text);
            request.startTime = uint.Parse(StartTimestamp.Text);
            request.endTime = uint.Parse(EndTimestamp.Text);

            int alarmRecordNum = 0;
            IntPtr pAlarmRecords = IntPtr.Zero;

            int ret = PlatformSDK.QueryAlarm(loginID, ref request, ref pAlarmRecords, &alarmRecordNum);

            var allXmlString = "";

            for (int i = 0; i < alarmRecordNum; ++i)
            {
                IntPtr pEventInfo = new IntPtr(pAlarmRecords.ToInt64() + Marshal.SizeOf(typeof(PlatformSDK.TQueryAlarmResponse)) * i);
                PlatformSDK.TQueryAlarmResponse alarmInfo = (PlatformSDK.TQueryAlarmResponse)Marshal.PtrToStructure(pEventInfo, typeof(PlatformSDK.TQueryAlarmResponse));
                var xmlString = Marshal.PtrToStringAnsi(alarmInfo.content);
                EventLog.Write("PlatformSDK.QueryAlarm, Content = {0}", xmlString);

                allXmlString += xmlString;
            }

            ResultBlock.Text = allXmlString;
        }
    }
}
