﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;
using PlatformSDKSample;
using System.Runtime.InteropServices;

namespace SynchronousPlayback
{
    class Program
    {
        static IntPtr hAvSyncPlaybackGroup = IntPtr.Zero;
        static IntPtr channel = IntPtr.Zero;
        static IntPtr channel2 = IntPtr.Zero;

        static void Main(string[] args)
        {
            int ret = PlatformSDK.Initial();
            EventLog.Write("PlatformSDK.Initial Ret = {0:X}", ret);

            uint startTime = 1576807200;    //2019/12/20 10:00:00
            uint endTime = 1576807260;      //2019/12/20 10:01:00
            short streamIndex = 1;

            //camera1
            TCreateChannelInfo info = new TCreateChannelInfo();
            info.serverIP = "127.0.0.1";
            info.serverUserName = "admin";
            info.serverPassword = "1";
            info.serverPort = 3454;
            info.cameraID = "C_1";
            info.streamIndex = streamIndex;
            info.startTime = startTime;
            info.endTime = endTime;
            info.capVersion = PlatformSDK.ECapabilityVersion.VAST;

            SynchronousPlayback.ViewCell viewcell = new SynchronousPlayback.ViewCell();
            channel = viewcell.CreateSyncChannel(ref info);

            //camera2
            TCreateChannelInfo info2 = new TCreateChannelInfo();
            info2.serverIP = "127.0.0.1";
            info2.serverUserName = "admin";
            info2.serverPassword = "1";
            info2.serverPort = 3454;
            info2.cameraID = "C_2";
            info2.streamIndex = streamIndex;
            info2.startTime = startTime;
            info2.endTime = endTime;
            info2.capVersion = PlatformSDK.ECapabilityVersion.VAST;

            SynchronousPlayback.ViewCell viewcell2 = new SynchronousPlayback.ViewCell();
            channel2 = viewcell2.CreateSyncChannel(ref info2);

            ret = PlatformSDK.CreateSyncPlaybackGroup(ref hAvSyncPlaybackGroup);
            EventLog.Write("PlatformSDK.CreateSyncPlaybackGroup Ret = {0:X}", ret);

            ret = PlatformSDK.InsertChannelToGroup(hAvSyncPlaybackGroup, channel);
            EventLog.Write("PlatformSDK.InsertChannelToGroup Ret = {0:X}", ret);
            ret = PlatformSDK.InsertChannelToGroup(hAvSyncPlaybackGroup, channel2);
            EventLog.Write("PlatformSDK.InsertChannelToGroup Ret = {0:X}", ret);

            var option = new PlatformSDK.TSDKSyncPlaybackOption();
            option.startTime = startTime;
            option.endTime = endTime;
            option.statusCB = null;
            option.statusContext = IntPtr.Zero;
            option.timeKind = PlatformSDK.ETimeKind.UTC;

            ret = PlatformSDK.StartSyncPlaybackGroup(hAvSyncPlaybackGroup, ref option);
            EventLog.Write("PlatformSDK.StartSyncPlaybackGroup Ret = {0:X}", ret);

            viewcell.Show();
            viewcell2.Show();

            Application.Run();
        }

        static public void seek(uint startTime, uint endTime)
        {
            var syncOption = new PlatformSDK.TPlaybackOption();
            syncOption.startTime = startTime;
            syncOption.endTime = endTime;

            IntPtr[] channelArray = { channel, channel2 };
            IntPtr pChannelList = Marshal.AllocHGlobal(channelArray.Length * Marshal.SizeOf(typeof(IntPtr)));
            Marshal.Copy(channelArray, 0, pChannelList, channelArray.Length);

            var channelList = new PlatformSDK.TSDKChannelList();
            channelList.dwChannelNum = (uint)channelArray.Length;
            channelList.ptChannelList = pChannelList;

            var ret = PlatformSDK.UpdateSyncPlaybackOption(hAvSyncPlaybackGroup, ref channelList, ref syncOption);
            EventLog.Write("PlatformSDK.UpdateSyncPlaybackOption Ret = {0:X}", ret);
        }
    }
}
